<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm0000000EquipesFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    // QUERY FRAME PRINCIPAL EQUIPES
    public function getEquipes()
    {
        $sql = "SELECT NREQUIPE, NMEQUIPE, IDATIVO FROM FCM_EQUIPE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirEquipe($params)
    {
        $sql = "INSERT INTO FCM_EQUIPE (
            NREQUIPE, NMEQUIPE, IDATIVO, NRORG, CDOPERINCLUSAO,NRORGINCLUSAO, DTINCLUSAO
        ) VALUES (
            :NREQUIPE, :NMEQUIPE, :IDATIVO, :NRORG, :CDOPERINCLUSAO, :NRORGINCLUSAO, SYSDATE
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizarEquipe($params)
    {
        $sql = "UPDATE FCM_EQUIPE 
                SET NMEQUIPE    = :NMEQUIPE,
                    CDOPERULTATU    = :CDOPERULTATU,
                    NRORGULTATU    = :NRORGULTATU,
                    IDATIVO        = :IDATIVO,
                    DTULTATU    = SYSDATE
              WHERE NREQUIPE    = :NREQUIPE";

        $this->connection->executeStatement($sql, $params);
    }

    public function getOperadorEquipe($params)
    {
        $sql = "SELECT NRRELACEQUIPEOPER, NREQUIPE, CDOPERADOR 
                   FROM FCM_RELACEQUIPEOPER
                  WHERE NREQUIPE = :NREQUIPE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function relacionarOperadorEquipe($params)
    {
        $sql = "INSERT INTO FCM_RELACEQUIPEOPER (
           NRRELACEQUIPEOPER, NREQUIPE, CDOPERADOR, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO, DTINCLUSAO
        ) VALUES (
            :NRRELACEQUIPEOPER, :NREQUIPE, :CDOPERADOR, :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO, :IDATIVO, SYSDATE
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function excluirEquipes($nr)
    {
        $sql = "DELETE FROM FCM_EQUIPE 
                 WHERE NREQUIPE IN ($nr)";

        $this->connection->executeStatement($sql);
    }
    
    public function excluirOperadorEquipe($filtro)
    {
        $sql = "DELETE FROM FCM_RELACEQUIPEOPER
                $filtro";

        $this->connection->executeStatement($sql);
    }

    // public function buscarTarefaEquipe($filtro)
    // {

        
    //     $sql = "SELECT FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.DTHORAAGEND,
    //                 FCM_CHECKLISTAGEND.IDSITUACAOAGEND, FCM_LOCALCLI.NMLOCALCLIENTE, CLIENTE.NMFANTCLIE
    //             FROM
    //                 FCM_EQUIPETAREFA
    //             JOIN 
    //                 FCM_CHECKLISTAGEND ON FCM_EQUIPETAREFA.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
    //             WHERE IDATIVO = 'S'" ;

    //     return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, [$filtro]);
    // }

    public function buscarTarefaEquipe($filtro)
    {
        $sql = "SELECT FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.DTHORAAGEND,
                    FCM_CHECKLISTAGEND.IDSITUACAOAGEND, FCM_LOCALCLI.NMLOCALCLIENTE, CLIENTE.NMFANTCLIE, FCM_CHECKLISTAGEND.IDATIVO
                FROM
                    FCM_EQUIPETAREFA
                JOIN 
                    FCM_CHECKLISTAGEND ON FCM_EQUIPETAREFA.NRCHECKLISTAGEND = FCM_CHECKLISTAGEND.NRCHECKLISTAGEND
                JOIN 
                    FCM_LOCALCLI ON FCM_CHECKLISTAGEND.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                JOIN 
                    CLIENTE ON CLIENTE.CDCLIENTE = FCM_LOCALCLI.CDCLIENTE
                WHERE FCM_EQUIPETAREFA.NREQUIPE = :NREQUIPE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $filtro);
    }

    // public function buscarTarefaEquipe($params)
    // {
    //     $sql = "
    //         SELECT 
    //             c.NMCHECKLISTAGEND, 
    //             c.NRCHECKLISTAGEND, 
    //             c.DTHORAAGEND, 
    //             c.IDSITUACAOAGEND, 
    //             l.NMLOCALCLIENTE, 
    //             cl.NMFANTCLIE
    //         FROM 
    //             FCM_EQUIPETAREFA r
    //         JOIN 
    //             FCM_CHECKLISTAGEND c ON r.NRCHECKLISTAGEND = c.NRCHECKLISTAGEND
    //         JOIN 
    //             FCM_LOCALCLI l ON c.NRLOCALCLIENTE = l.NRLOCALCLIENTE
    //         JOIN 
    //             CLIENTE cl ON cl.CDCLIENTE = l.CDCLIENTE
    //         WHERE 
    //             r.NREQUIPE = :NREQUIPE
    //             AND c.IDATIVO = 'S'
    //     ";
    
    //     // Verifica se o parâmetro está configurado corretamente.
    //     $params = is_array($params) && isset($params['NREQUIPE']) ? $params : ['NREQUIPE' => null];
    
    //     // Executa a consulta e retorna os resultados.
    //     return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    // }    
}