<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class Fm00003000ChecklistFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    /* INICIO TAB DE CHECKLIST */
    public function getTarefasCheck($parametros, $filtro)
    {
        //  Busca as tarefas associadas a um checklist
        $sql = "SELECT FCM_CHECKLISTAGEND.NMCHECKLISTAGEND, FCM_CHECKLISTAGEND.NRCHECKLISTAGEND, FCM_CHECKLISTAGEND.NRLOCALCLIENTE, FCM_LOCALCLI.NMLOCALCLIENTE, FCM_CHECKLISTAGEND.DTHORAAGEND, 
                    FCM_CHECKLISTAGEND.IDATIVO, CLIENTE.NMRAZSOCCLIE || '-' || CLIENTE.NMFANTCLIE AS CLIENTE,
                    CASE FCM_CHECKLISTAGEND.IDSITUACAOAGEND
                        WHEN '1' THEN 'Pendente'
                        WHEN '2' THEN 'Em andamento'
                        WHEN '3' THEN 'Concluído'
                        WHEN '4' THEN 'Cancelado'
                        WHEN '6' THEN 'Tarefa reportada (Aprovação Pendente)'
                        ELSE  FCM_CHECKLISTAGEND.IDSITUACAOAGEND
                    END AS IDSITUACAOAGEND
                FROM FCM_CHECKLISTAGEND
                JOIN FCM_LOCALCLI ON FCM_CHECKLISTAGEND.NRLOCALCLIENTE = FCM_LOCALCLI.NRLOCALCLIENTE
                JOIN CLIENTE ON CLIENTE.CDCLIENTE = FCM_LOCALCLI.CDCLIENTE
                WHERE NRCHECKLIST = :NRCHECKLIST
                $filtro";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getNrtarefachk($parametros)
    {
        $sql = "SELECT NRTAREFACHK FROM FCM_TAREFACHK WHERE NRCHECKLIST = :NRCHECKLIST";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function deleteChecklist($nrchecklist, $nrtarefachk)// EM USO
    {

        $sql = "DELETE FCM_ESCOPOSTAREFACHK 
                WHERE NRCHECKLIST IN ($nrchecklist)";

        $this->connection->executeStatement($sql);

        $sql1 = "DELETE FCM_CRITERIOTAREFACHK 
                WHERE NRTAREFACHK IN  ($nrtarefachk)";

        $this->connection->executeStatement($sql1);

        $sql2 = "DELETE FCM_TAREFACHK
                WHERE NRCHECKLIST IN ($nrchecklist)";

        $this->connection->executeStatement($sql2);

        $sql3 = "DELETE FCM_ATIVIDADECHK
                WHERE NRCHECKLIST IN ($nrchecklist)";

        $this->connection->executeStatement($sql3);

        $sql4 = "DELETE FCM_CHECKLIST 
                WHERE NRCHECKLIST IN ($nrchecklist)";

        $this->connection->executeStatement($sql4);
    }

    public function getAtividadesChecklist($parametros)
    {

        $sql = "SELECT FCM_ITEMCHECKLIST.NRTAREFA, FCM_TAREFA.NMTAREFA 
                    FROM FCM_ITEMCHECKLIST
                    JOIN FCM_TAREFA
                    ON FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                    WHERE FCM_ITEMCHECKLIST.NRATIVIDADE IN ({$parametros})
                    AND FCM_ITEMCHECKLIST.IDATIVO = 'S'
                    ORDER BY FCM_TAREFA.NMTAREFA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getDadosChecklist($nrTarefa, $nratividade)
    {
        $sql = "SELECT DISTINCT TO_CHAR(FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA) AS CODIGO, 
                                FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA AS CODIGOAUX, 
                                FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA AS NOME, 
                                'Escopo' AS TIPO, 
                                NULL AS CODIGOPAI, 
                                NULL AS CODIGOPAIAUX, 
                                NULL AS IDATIVO
                FROM FCM_ITEMCHECKLIST
                JOIN FCM_ITEMCHECKLISTESC 
                  ON FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                JOIN FCM_ESCOPOSTAREFA
                  ON FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA = FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA
                WHERE FCM_ITEMCHECKLIST.IDATIVO = 'S'
                AND FCM_ITEMCHECKLIST.NRTAREFA IN ($nrTarefa)
                 AND FCM_ITEMCHECKLIST.NRATIVIDADE IN ($nratividade)
    
                UNION ALL 
    
                SELECT DISTINCT FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA || '_' || FCM_ITEMCHECKLIST.NRTAREFA AS CODIGO, 
                                FCM_ITEMCHECKLIST.NRTAREFA AS CODIGOAUX,  
                                FCM_TAREFA.NMTAREFA AS NOME, 
                                'Atividade' AS TIPO, 
                                TO_CHAR(FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA) AS CODIGOPAI, 
                                FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA AS CODIGOPAIAUX, 
                                FCM_ITEMCHECKLIST.IDATIVO
                FROM FCM_ITEMCHECKLIST
                JOIN FCM_TAREFA
                  ON FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                JOIN FCM_ITEMCHECKLISTESC 
                  ON FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                WHERE FCM_ITEMCHECKLIST.IDATIVO = 'S'
                AND FCM_ITEMCHECKLIST.NRTAREFA  IN ($nrTarefa)
                 AND FCM_ITEMCHECKLIST.NRATIVIDADE IN ($nratividade)
    
                UNION ALL
    
                SELECT DISTINCT TO_CHAR(FCM_ITEMCHECKLISTCRIT.NRCRITERIOTAREFA) AS CODIGO, 
                                FCM_ITEMCHECKLISTCRIT.NRCRITERIOTAREFA AS CODIGOAUX, 
                                FCM_CRITERIOTAREFA.DSCRITERIOTAREFA AS NOME, 
                                'Critério' AS TIPO,  
                                FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA || '_' || FCM_ITEMCHECKLIST.NRTAREFA AS CODIGOPAI, 
                                FCM_ITEMCHECKLIST.NRTAREFA AS CODIGOPAIAUX, 
                                FCM_ITEMCHECKLIST.IDATIVO
                FROM FCM_ITEMCHECKLIST
                JOIN FCM_ITEMCHECKLISTCRIT 
                  ON FCM_ITEMCHECKLISTCRIT.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                JOIN FCM_ITEMCHECKLISTESC 
                  ON FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                JOIN FCM_CRITERIOTAREFA 
                  ON FCM_CRITERIOTAREFA.NRCRITERIOTAREFA = FCM_ITEMCHECKLISTCRIT.NRCRITERIOTAREFA
                WHERE FCM_ITEMCHECKLIST.IDATIVO = 'S'
                  AND FCM_ITEMCHECKLIST.NRTAREFA IN ($nrTarefa)
                  AND FCM_ITEMCHECKLIST.NRATIVIDADE IN ($nratividade)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function salvarChecklist($parametros)
    {

        $sql = "INSERT INTO FCM_CHECKLIST (NRCHECKLIST, NMCHECKLIST, NRTIPOLOCALCLI, IDATIVO, NRORG, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRCHECKLIST, :NMCHECKLIST, :NRTIPOLOCALCLI, 'S', :NRORG, :NRORGINCLUSAO, SYSDATE, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function salvarItens($parametros)
    {

        $sql = "INSERT INTO FCM_ATIVIDADECHK (NRATIVIDADECHK, NRATIVIDADE, NRCHECKLIST, IDATIVO, NRORG, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRATIVIDADECHK, :NRATIVIDADE, :NRCHECKLIST, 'S', :NRORG, :NRORGINCLUSAO, SYSDATE, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function verificaExistenciaAtividade($parametros)
    {

        $sql = "SELECT COUNT(*) CONT
                FROM FCM_ITEMCHECKLIST
                WHERE NRATIVIDADE = :NRATIVIDADE
                AND NRTAREFA = :NRTAREFA";


        $st = $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
        return $st[0]['CONT'];
    }

    public function salvarAtividade($parametros)
    {
        $sql = "INSERT INTO FCM_TAREFACHK (NRTAREFACHK, NRTAREFA, NRCHECKLIST, NRATIVIDADECHK, IDATIVO, NRORG, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRTAREFACHK, :NRTAREFA, :NRCHECKLIST, :NRATIVIDADECHK, 'S', :NRORG, :NRORGINCLUSAO, SYSDATE, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function salvarCriterio($parametros)
    {
        $sql = "INSERT INTO FCM_CRITERIOTAREFACHK (NRCRITERIOTAREFACHK, NRCRITERIOTAREFA, NRTAREFACHK, IDATIVO, NRORG, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRCRITERIOTAREFACHK, :NRCRITERIOTAREFA, :NRTAREFACHK, 'S', :NRORG, :NRORGINCLUSAO, SYSDATE, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function salvarEscopo($parametros)
    {
        $sql = "INSERT INTO FCM_ESCOPOSTAREFACHK (NRESCOPOSTAREFACHK, NRCHECKLIST, NRTAREFACHK, NRESCOPOSTAREFA, IDATIVO, NRORG, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRESCOPOSTAREFACHK, :NRCHECKLIST, :NRTAREFACHK, :NRESCOPOSTAREFA, 'S', :NRORG, :NRORGINCLUSAO, SYSDATE, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getChecklist()
    {
        $sql = "SELECT FCM_CHECKLIST.NRCHECKLIST, 
                       FCM_CHECKLIST.NMCHECKLIST, 
                       FCM_TIPOLOCALCLI.NMTIPOLOCALCLI, 
                       CASE FCM_CHECKLIST.IDATIVO 
                           WHEN 'S' THEN 'Sim' 
                           WHEN 'N' THEN 'Não' 
                           ELSE FCM_CHECKLIST.IDATIVO 
                       END AS IDATIVO 
                FROM FCM_CHECKLIST
                JOIN FCM_TIPOLOCALCLI
                  ON FCM_TIPOLOCALCLI.NRTIPOLOCALCLI = FCM_CHECKLIST.NRTIPOLOCALCLI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getDadosChecklistEdicao($parametros)
    {
        $sql1 = "SELECT NRCHECKLIST, NMCHECKLIST, IDATIVO, NRTIPOLOCALCLI,
        (SELECT RTRIM(XMLAGG(XMLELEMENT(E, NRATIVIDADE, ',')
                                    .EXTRACT('//text()')
                                    ORDER BY NRATIVIDADE
                                ).GETCLOBVAL(), ','
                            ) AS ITENS
                    FROM FCM_ATIVIDADECHK 
                    WHERE FCM_ATIVIDADECHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST) AS NRATIVIDADE,
            (SELECT RTRIM(XMLAGG(XMLELEMENT(E, NRTAREFA, ',')
                                    .EXTRACT('//text()')
                                    ORDER BY NRTAREFA
                                ).GETCLOBVAL(), ','
                            ) AS ATIVIDADES
                    FROM FCM_TAREFACHK 
                    WHERE FCM_TAREFACHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST) AS NRTAREFA
            FROM FCM_CHECKLIST
            WHERE NRCHECKLIST = :NRCHECKLIST";

        $dadosGerais = $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql1, $parametros, [], null, null, null, array('NRATIVIDADE', 'NRTAREFA'));

        $sql = "SELECT DISTINCT FCM_ESCOPOSTAREFACHK.NRESCOPOSTAREFA AS CODIGO, 
                                FCM_ESCOPOSTAREFA.NMESCOPOSTAREFA AS NOME, 
                                'Escopo' AS TIPO, 
                                NULL AS CODIGOPAI
                        FROM FCM_ESCOPOSTAREFACHK
                        JOIN FCM_CHECKLIST 
                        ON FCM_CHECKLIST.NRCHECKLIST = FCM_ESCOPOSTAREFACHK.NRCHECKLIST
                        JOIN FCM_ESCOPOSTAREFA
                        ON FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA = FCM_ESCOPOSTAREFACHK.NRESCOPOSTAREFA
                        WHERE FCM_CHECKLIST.NRCHECKLIST = :NRCHECKLIST
            
                        UNION ALL 
            
                        SELECT DISTINCT FCM_TAREFACHK.NRTAREFA AS CODIGO, 
                                        FCM_TAREFA.NMTAREFA AS NOME, 
                                        'Atividade' AS TIPO, 
                                        FCM_ESCOPOSTAREFACHK.NRESCOPOSTAREFA AS CODIGOPAI
                        FROM FCM_TAREFACHK
                        JOIN FCM_TAREFA ON FCM_TAREFA.NRTAREFA = FCM_TAREFACHK.NRTAREFA
                        JOIN FCM_CHECKLIST 
                        ON FCM_CHECKLIST.NRCHECKLIST = FCM_TAREFACHK.NRCHECKLIST
                        JOIN FCM_ESCOPOSTAREFACHK 
                        ON FCM_ESCOPOSTAREFACHK.NRCHECKLIST = FCM_CHECKLIST.NRCHECKLIST
                        AND FCM_TAREFACHK.NRTAREFACHK = FCM_ESCOPOSTAREFACHK.NRTAREFACHK
                        WHERE FCM_CHECKLIST.NRCHECKLIST = :NRCHECKLIST
            
                        UNION ALL
            
                        SELECT DISTINCT FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA AS CODIGO, 
                                        FCM_CRITERIOTAREFA.DSCRITERIOTAREFA AS NOME, 
                                        'Critério' AS TIPO,  
                                        FCM_TAREFACHK.NRTAREFA AS CODIGOPAI
                        FROM FCM_CRITERIOTAREFACHK
                        JOIN FCM_CRITERIOTAREFA 
                        ON FCM_CRITERIOTAREFA.NRCRITERIOTAREFA = FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA
                        JOIN FCM_TAREFACHK ON FCM_TAREFACHK.NRTAREFACHK = FCM_CRITERIOTAREFACHK.NRTAREFACHK
                        JOIN FCM_CHECKLIST 
                        ON FCM_CHECKLIST.NRCHECKLIST = FCM_TAREFACHK.NRCHECKLIST
                        WHERE FCM_CHECKLIST.NRCHECKLIST = :NRCHECKLIST";

        $dadosComplementares = $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
        return [$dadosGerais, $dadosComplementares];
    }

    public function verificarNomeItens($paramsQuery)
    {
        try {

            $sql = "SELECT NRATIVIDADE, NMATIVIDADE, DSCORIDATIVIDADE
            FROM FCM_ATIVIDADE
            WHERE UPPER(NMATIVIDADE) LIKE UPPER(:NOME)
            AND NRORG = :NRORG";

            return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $paramsQuery);
        } catch (\Throwable $th) {
            throw $th;
        }
    }

    public function editarChecklist($params)
    {

        $sql = "UPDATE FCM_CHECKLIST
                   SET NMCHECKLIST    = :NMCHECKLIST,
                       NRORGULTATU    = :NRORGULTATU,
                       IDATIVO        = :IDATIVO,
                       CDOPERULTATU   = :CDOPERULTATU,
                       DTULTATU       = SYSDATE
                 WHERE NRCHECKLIST    = :NRCHECKLIST";

        $this->connection->executeStatement($sql, $params);
    }
    /* FIM TAB DE CHECKLIST */


    /* FIM TAB DE ITENS */

    public function getItensChecklist()// em uso
    {
        $sql = "SELECT NRATIVIDADE, NMATIVIDADE, DSCORIDATIVIDADE, IDATIVO 
                FROM FCM_ATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirItemChecklist($parametros)// em uso
    {

        $sql = "INSERT INTO FCM_ATIVIDADE (NRATIVIDADE, NMATIVIDADE, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO, DSCORIDATIVIDADE)
        VALUES (:NRATIVIDADE, :NMATIVIDADE, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :DSCORIDATIVIDADE)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getChecklistRelacionadoAtivos($parametros, $criterios, $escopos, $filtro)// em uso
    {
        $sql = "SELECT FCM_CHECKLIST.NRCHECKLIST,  FCM_CHECKLIST.NMCHECKLIST, FCM_CHECKLIST.IDATIVO
                    FROM FCM_ITEMCHECKLIST
                    JOIN FCM_ATIVIDADECHK ON FCM_ATIVIDADECHK.NRATIVIDADE = FCM_ITEMCHECKLIST.NRATIVIDADE
                    JOIN FCM_TAREFACHK ON FCM_TAREFACHK.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                    JOIN FCM_ITEMCHECKLISTCRIT ON FCM_ITEMCHECKLISTCRIT.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                    JOIN FCM_CRITERIOTAREFACHK  ON FCM_CRITERIOTAREFACHK.NRTAREFACHK = FCM_TAREFACHK.NRTAREFACHK
                    AND FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA = FCM_ITEMCHECKLISTCRIT.NRCRITERIOTAREFA
                    JOIN FCM_ITEMCHECKLISTESC ON FCM_ITEMCHECKLISTESC.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST
                    JOIN FCM_ESCOPOSTAREFACHK ON FCM_ESCOPOSTAREFACHK.NRTAREFACHK = FCM_TAREFACHK.NRTAREFACHK
                    AND FCM_ESCOPOSTAREFACHK.NRESCOPOSTAREFA = FCM_ITEMCHECKLISTESC.NRESCOPOSTAREFA
                    JOIN FCM_CHECKLIST 
                        ON FCM_CHECKLIST.NRCHECKLIST = FCM_ATIVIDADECHK.NRCHECKLIST 
                        AND FCM_CHECKLIST.NRCHECKLIST = FCM_TAREFACHK.NRCHECKLIST
                        AND FCM_CHECKLIST.NRCHECKLIST = FCM_ESCOPOSTAREFACHK.NRCHECKLIST
                    WHERE FCM_ATIVIDADECHK.NRATIVIDADE = :NRATIVIDADE 
                    AND FCM_TAREFACHK.NRTAREFA = :NRTAREFA
                    AND FCM_ITEMCHECKLIST.NRITEMCHECKLIST = :NRITEMCHECKLIST
                    AND FCM_CRITERIOTAREFACHK.NRCRITERIOTAREFA IN ($criterios)
                    AND FCM_ESCOPOSTAREFACHK.NRESCOPOSTAREFA IN ($escopos)
                    $filtro";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getChecklistsAssociadosItens($parametros, $filtro)
    {
        $sql = "SELECT CHK.NRCHECKLIST, CHK.NMCHECKLIST, CHK.IDATIVO
                FROM FCM_ATIVIDADECHK ATVCHK
                JOIN FCM_CHECKLIST CHK ON ATVCHK.NRCHECKLIST = CHK.NRCHECKLIST
                WHERE ATVCHK.NRATIVIDADE = :NRATIVIDADE
                $filtro";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function getItemChecklistAssociadoItem($parametros)
    {
        $sql = "SELECT * FROM FCM_ITEMCHECKLIST WHERE NRATIVIDADE = :NRATIVIDADE";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function excluirItem($params)// em uso
    {
        $sql = "DELETE FROM FCM_ATIVIDADE
        WHERE NRATIVIDADE = :NRATIVIDADE";

        $this->connection->executeStatement($sql, $params);
    }

    public function excluirItemChecklist($nritemchecklist)// EM USO
    {

        $sql = "DELETE FCM_ITEMCHECKLISTCRIT 
                WHERE NRITEMCHECKLIST IN ($nritemchecklist)";

        $this->connection->executeStatement($sql);

        $sql1 = "DELETE FCM_ITEMCHECKLISTESC 
                WHERE NRITEMCHECKLIST IN  ($nritemchecklist)";

        $this->connection->executeStatement($sql1);

        $sql2 = "DELETE FCM_ITEMCHECKLIST
                WHERE NRITEMCHECKLIST IN ($nritemchecklist)";

        $this->connection->executeStatement($sql2);
    }

    public function updateItem($parametros)
    {
        $sql = "UPDATE FCM_ATIVIDADE
                SET IDATIVO      = :IDATIVO,
                    DTULTATU     = SYSDATE,
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU  = :NRORGULTATU
                WHERE NRATIVIDADE = :NRATIVIDADE";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateItemChecklistEsc($parametros)
    {
        $sql = "UPDATE FCM_ITEMCHECKLISTESC
                SET IDATIVO      = :IDATIVO,
                    DTULTATU     = SYSDATE,
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU  = :NRORGULTATU
                WHERE NRITEMCHECKLIST = :NRITEMCHECKLIST";

        $this->connection->executeStatement($sql, $parametros);

    }

    public function updateItemChecklistCrit($parametros)
    {
        $sql = "UPDATE FCM_ITEMCHECKLISTCRIT
                SET IDATIVO      = :IDATIVO,
                    DTULTATU     = SYSDATE,
                    CDOPERULTATU = :CDOPERULTATU,
                    NRORGULTATU  = :NRORGULTATU
                WHERE NRITEMCHECKLIST = :NRITEMCHECKLIST";

        $this->connection->executeStatement($sql, $parametros);

    }

    public function getCriteriosChecklist($filtro)
    {

        $sql = "SELECT * FROM FCM_CRITERIOTAREFA
                $filtro";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTarefasChecklist($parametros)
    {

        $sql = "SELECT 
                FCM_ITEMCHECKLIST.NRITEMCHECKLIST, FCM_ITEMCHECKLIST.NRTAREFA, FCM_TAREFA.NMTAREFA, FCM_ITEMCHECKLIST.IDATIVO,
                (SELECT RTRIM(XMLAGG(XMLELEMENT(E, CT.NRCRITERIOTAREFA, ',')
                                    .EXTRACT('//text()')
                                    ORDER BY CT.NRCRITERIOTAREFA
                                ).GETCLOBVAL(), ','
                            ) AS NMCRITERIO
                    FROM FCM_ITEMCHECKLISTCRIT CT
                    WHERE CT.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST) AS NRCRITERIOTAREFA, 
                    
                    (SELECT RTRIM(XMLAGG(XMLELEMENT(E, EI.NRESCOPOSTAREFA, ',')
                                    .EXTRACT('//text()')
                                    ORDER BY EI.NRESCOPOSTAREFA
                                ).GETCLOBVAL(), ','
                            ) AS NMESCOPO
                    FROM FCM_ITEMCHECKLISTESC EI
                    WHERE EI.NRITEMCHECKLIST = FCM_ITEMCHECKLIST.NRITEMCHECKLIST) AS NRESCOPOSTAREFA
                                            FROM FCM_ITEMCHECKLIST
                                    LEFT JOIN FCM_TAREFA
                                            ON FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                                    LEFT JOIN FCM_CRITERIOTAREFA
                                            ON FCM_CRITERIOTAREFA.NRCRITERIOTAREFA = FCM_ITEMCHECKLIST.NRCRITERIOTAREFA
                                    LEFT JOIN FCM_ESCOPOSTAREFA
                                            ON FCM_ESCOPOSTAREFA.NRESCOPOSTAREFA = FCM_ITEMCHECKLIST.NRESCOPOSTAREFA
                                        WHERE FCM_ITEMCHECKLIST.NRATIVIDADE = :NRATIVIDADE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros, [], null, null, null, array('NRESCOPOSTAREFA', 'NRCRITERIOTAREFA'));
    }

    public function inserirRelacaoItemChecklist($parametros) //em uso
    {
        $sql = "INSERT INTO FCM_ITEMCHECKLIST (NRITEMCHECKLIST, NRATIVIDADE, NRTAREFA, NRCRITERIOTAREFA, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO, NRESCOPOSTAREFA)
        VALUES (:NRITEMCHECKLIST, :NRATIVIDADE, :NRTAREFA, :NRCRITERIOTAREFA, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :NRESCOPOSTAREFA)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateTarefaChecklist($parametros)
    {
        $sql = "UPDATE FCM_ITEMCHECKLIST
        SET NRATIVIDADE     = :NRATIVIDADE,
            NRTAREFA        = :NRTAREFA,
            NRCRITERIOTAREFA= :NRCRITERIOTAREFA,
            IDATIVO         = :IDATIVO,
            NRESCOPOSTAREFA = :NRESCOPOSTAREFA,
            DTULTATU        =  SYSDATE,
            CDOPERULTATU    = :CDOPERULTATU,
            NRORGULTATU     = :NRORGULTATU
        WHERE NRITEMCHECKLIST = :NRITEMCHECKLIST";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirCriterioItemChecklist($parametros)// em uso
    {
        $sql = " INSERT INTO FCM_ITEMCHECKLISTCRIT (NRITEMCHECKLISTCRIT, NRITEMCHECKLIST, NRCRITERIOTAREFA, NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRITEMCHECKLISTCRIT, :NRITEMCHECKLIST, :NRCRITERIOTAREFA, :NRORG, 'S', SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirEscopoItemChecklist($parametros)// em uso
    {
        $sql = "INSERT INTO FCM_ITEMCHECKLISTESC(NRITEMCHECKLISTESC, NRITEMCHECKLIST, NRESCOPOSTAREFA, NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                VALUES (:NRITEMCHECKLISTESC, :NRITEMCHECKLIST, :NRESCOPOSTAREFA, :NRORG, 'S', SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateItemChecklist($parametros)
    {

        $sql = "UPDATE FCM_ITEMCHECKLIST 
                SET IDATIVO = :IDATIVO,
                    NRORGULTATU = :NRORGULTATU,
                    DTULTATU = SYSDATE, 
                    CDOPERULTATU = :CDOPERULTATU
                WHERE NRITEMCHECKLIST = :NRITEMCHECKLIST";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateEscoposItemChecklist($parametros)// em uso
    {

        $sql = "UPDATE FCM_ITEMCHECKLISTESC 
                SET IDATIVO = :IDATIVO,
                    NRORGULTATU = :NRORGULTATU,
                    DTULTATU = SYSDATE, 
                    CDOPERULTATU = :CDOPERULTATU
                WHERE NRITEMCHECKLIST = :NRITEMCHECKLIST";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateCriteriosItemChecklist($parametros)
    {
        $sql = "UPDATE FCM_ITEMCHECKLISTCRIT 
                SET IDATIVO = :IDATIVO,
                    NRORGULTATU = :NRORGULTATU,
                    DTULTATU = SYSDATE, 
                    CDOPERULTATU = :CDOPERULTATU
                WHERE NRITEMCHECKLIST = :NRITEMCHECKLIST";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateCorItemChecklist($parametros)
    {

        $sql = "UPDATE FCM_ATIVIDADE
                    SET DSCORIDATIVIDADE = :DSCORIDATIVIDADE,
                        DTULTATU = SYSDATE,
                        CDOPERULTATU = :CDOPERULTATU, 
                        NRORGULTATU = :NRORGULTATU
                WHERE NRATIVIDADE = :NRATIVIDADE";

        $this->connection->executeStatement($sql, $parametros);
    }
    /* FIM TAB DE ITENS */

    /* INICIO TAB ATIVIDADES E CRITÉRIOS */
    public function getAtividadesCriterios()// em uso
    {
        $sql = "SELECT 'T'||TAR.NRTAREFA AS CODIGO, 
                       TAR.NMTAREFA AS NOME, 
                       NULL AS CODIGOPAI, 
                       'Atividade' AS TIPO, 
                       TAR.NRTAREFA AS NR, 
                       NRPRIORIDADETAREFA AS PRIORIDADE,
                       TAR.IDATIVO AS IDATIVO,
                       (SELECT RTRIM(XMLAGG(XMLELEMENT(E, ATIV.NRHABILIDADE, ',')
                               .EXTRACT('//text()')
                               ORDER BY ATIV.NRHABILIDADE
                           ).GETCLOBVAL(), ',') AS HABILIDADE
                        FROM FCM_RELACHABATIV ATIV
                        WHERE TAR.NRTAREFA = ATIV.NRTAREFA
                       ) AS HABILIDADE
                FROM FCM_TAREFA TAR 
    
                UNION ALL
    
                SELECT 'C'||CRI.NRCRITERIOTAREFA AS CODIGO, 
                       CRI.DSCRITERIOTAREFA AS NOME, 
                       'T'||CRI.NRTAREFA AS CODIGOPAI, 
                       'Critério' AS TIPO, 
                       CRI.NRCRITERIOTAREFA AS NR, 
                       NULL AS PRIORIDADE, 
                       CRI.IDATIVO AS IDATIVO,
                       (SELECT RTRIM(XMLAGG(XMLELEMENT(E, ATIV.NRHABILIDADE, ',')
                               .EXTRACT('//text()')
                               ORDER BY ATIV.NRHABILIDADE
                           ).GETCLOBVAL(), ',') AS HABILIDADE
                        FROM FCM_RELACHABATIV ATIV
                        WHERE CRI.NRTAREFA = ATIV.NRTAREFA
                       ) AS HABILIDADE
                FROM FCM_CRITERIOTAREFA CRI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getAtividadesAtivas()
    {
        $sql = "SELECT 
                    FCM_TAREFA.NRTAREFA, 
                    FCM_TAREFA.NMTAREFA,
                    CASE 
                        WHEN FCM_TAREFA.IDATIVO = 'S' THEN 0
                        WHEN FCM_TAREFA.IDATIVO = 'N' THEN 1
                        ELSE NULL
                    END AS IDATIVO 
                FROM FCM_TAREFA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirCriterio($parametros)
    {

        $sql = "INSERT INTO FCM_CRITERIOTAREFA (NRCRITERIOTAREFA, DSCRITERIOTAREFA, NRTAREFA, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
        VALUES (:NRCRITERIOTAREFA, :DSCRITERIOTAREFA, :NRTAREFA, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getItensAssociadosCriterios($parametros) // em uso
    {
        $sql = "SELECT FCM_ITEMCHECKLISTCRIT.NRITEMCHECKLISTCRIT, FCM_ITEMCHECKLIST.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                FROM FCM_ITEMCHECKLISTCRIT
                JOIN FCM_ITEMCHECKLIST
                ON FCM_ITEMCHECKLIST.NRITEMCHECKLIST = FCM_ITEMCHECKLISTCRIT.NRITEMCHECKLIST
                JOIN FCM_ATIVIDADE
                ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ITEMCHECKLIST.NRATIVIDADE
                WHERE  FCM_ITEMCHECKLISTCRIT.NRCRITERIOTAREFA = :NRCRITERIOTAREFA 
                AND FCM_ITEMCHECKLIST.IDATIVO = 'S'";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }

    public function excluirCriterio($parametros) //em uso
    {
        $sql = "DELETE FROM FCM_CRITERIOTAREFA 
                WHERE NRCRITERIOTAREFA IN ($parametros)";

        $this->connection->executeStatement($sql);
    }

    public function getItensAssociadosAtividades($parametros) // em uso
    {
        $sql = "SELECT FCM_ITEMCHECKLIST.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                FROM FCM_ITEMCHECKLIST
                JOIN FCM_ATIVIDADE
                ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ITEMCHECKLIST.NRATIVIDADE
                JOIN FCM_TAREFA 
                ON FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                WHERE  FCM_TAREFA.NRTAREFA = :NRTAREFA
                AND FCM_ITEMCHECKLIST.IDATIVO = 'S'";

        return $this->connection->executeQuery($sql, $parametros)->fetchAllAssociative();
    }


    public function excluirAtividades($parametros)// em uso
    {
        $sql = "DELETE FROM FCM_TAREFA 
                WHERE NRTAREFA IN ($parametros)";

        $this->connection->executeStatement($sql);
    }

    public function updateCriterio($parametros)// em uso
    {

        $sql = "UPDATE FCM_CRITERIOTAREFA
                        SET DSCRITERIOTAREFA = :DSCRITERIOTAREFA,
                            DTULTATU = SYSDATE,
                            CDOPERULTATU = :CDOPERULTATU, 
                            NRORGULTATU = :NRORGULTATU,
                            IDATIVO = :IDATIVO
                    WHERE NRCRITERIOTAREFA = :NRCRITERIOTAREFA";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirAtividade($parametros)// em uso
    {

        $sql = "INSERT INTO FCM_TAREFA(NRTAREFA, NMTAREFA, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO, NRPRIORIDADETAREFA)
        VALUES (:NRTAREFA, :NMTAREFA, 'S', :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :NRPRIORIDADETAREFA)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateAtividade($parametros)// em uso
    {

        $sql = "UPDATE FCM_TAREFA
                        SET NMTAREFA = :NMTAREFA,
                            DTULTATU = SYSDATE,
                            CDOPERULTATU = :CDOPERULTATU, 
                            NRORGULTATU = :NRORGULTATU,
                            IDATIVO = :IDATIVO,
                            NRPRIORIDADETAREFA  = :NRPRIORIDADETAREFA
                    WHERE NRTAREFA = :NRTAREFA";

        $this->connection->executeStatement($sql, $parametros);
    }
    /* FIM TAB ATIVIDADES E CRITÉRIOS */

    /* INICIO TAB DE ESCOPOS */
    public function getEscoposServicos() // Em uso
    {

        $sql = "SELECT * FROM FCM_ESCOPOSTAREFA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function inserirEscopoServico($parametros)// Em uso
    {

        $sql = "INSERT INTO FCM_ESCOPOSTAREFA (NRESCOPOSTAREFA, NMESCOPOSTAREFA, IDATIVO, NRORG, DTINCLUSAO, CDOPERINCLUSAO, NRORGINCLUSAO)
        VALUES (:NRESCOPOSTAREFA, :NMESCOPOSTAREFA, :IDATIVO, :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO)";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function updateEscopoServico($parametros)// Em uso
    {
        $sql = "UPDATE FCM_ESCOPOSTAREFA
                SET NMESCOPOSTAREFA = :NMESCOPOSTAREFA,
                    IDATIVO = :IDATIVO,
                    NRORG = :NRORG,
                    DTULTATU = SYSDATE,
                    CDOPERULTATU = :CDOPERINCLUSAO, 
                    NRORGULTATU = :NRORGINCLUSAO
                WHERE NRESCOPOSTAREFA = :NRESCOPOSTAREFA";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function excluirEscopos($parametros)// Em uso
    {
        $sql = "DELETE FROM FCM_ESCOPOSTAREFA 
                WHERE NRESCOPOSTAREFA IN ($parametros)";

        $this->connection->executeStatement($sql);
    }

    public function getEscoposUtil($params, $filtro)// Em uso
    {
        $sql = "SELECT DISTINCT FCM_ITEMCHECKLIST.NRITEMCHECKLIST, FCM_TAREFA.NRTAREFA , FCM_TAREFA.NMTAREFA, FCM_ATIVIDADE.NRATIVIDADE, FCM_ATIVIDADE.NMATIVIDADE
                    FROM FCM_ITEMCHECKLIST
                    JOIN FCM_TAREFA ON FCM_TAREFA.NRTAREFA = FCM_ITEMCHECKLIST.NRTAREFA
                    JOIN FCM_ATIVIDADE ON FCM_ATIVIDADE.NRATIVIDADE = FCM_ITEMCHECKLIST.NRATIVIDADE
                    WHERE   FCM_ITEMCHECKLIST.NRITEMCHECKLIST IN (SELECT DISTINCT NRITEMCHECKLIST FROM FCM_ITEMCHECKLISTESC WHERE NRESCOPOSTAREFA  = :NRESCOPOSTAREFA)
                    $filtro";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }
    /* FIM TAB DE ESCOPOS */
}
